//Code for the table set control behavior

var modSetStr="";
var setStr="";

function expand(doc) {
	doc.style.height="auto";
}

function collapse(doc) {
	doc.style.height=1;
	doc.style.overflowY="auto";
}

function deleteRow(table, row) {
	
	var regEx=/<A>|<a>/;
	
	if (regEx.test(table.rows[row].cells[0].childNodes[0].outerHTML) ) {
		if (modSetStr!="") modSetStr+=", ";
		modSetStr+= (row+"-"+table.id+"/delete");
	}
	
	table.deleteRow(row);
	
	//Check whether we need to delete the next row (mechanism)
	var chkRow=table.rows[row];
	regEx=/Mechanism Arguments/;

	if (regEx.test(chkRow.cells[0].childNodes[0].innerHTML)) {
		table.deleteRow(row);
		
		for (var i=row;i<table.rows.length-1;i+=2) {
			table.rows[i].cells[1].innerHTML=getDelButStr(table.id, i);
		}
		
	} else {
		for (var i=row;i<table.rows.length-1;i++) {
			table.rows[i].cells[1].innerHTML=getDelButStr(table.id, i);
			
			if (table.rows[i].cells[0].childNodes[0].type!='text' &&
				table.rows[i].cells[0].childNodes[0].innerText!="PICK" &&
				table.rows[i].cells[0].childNodes[0].innerText!="CONFIG" &&
				table.rows[i].cells[0].childNodes[0].innerText!="CREDENTIAL") {
				table.rows[i].cells[2].innerHTML=getModButStr(table.id, i);
			}
		}
	}
}

function insert (func, depth) {

// func is a string indicate what is being insert
// depth is the current depth of the div

	var tableStr="mytable"+depth;
	var table=document.all(tableStr);

//Do the checking if we will insert a row
	if (func=="BIND_VAR"  && table.rows.length>=2) {
		window.alert("There can only be one binding variable.");
		return;
	}

//Look for the appropriate place to put the element
	var row=document.createElement("TR");
	var addLoc=table.rows[table.rows.length-1];
	addLoc.insertAdjacentElement("beforeBegin", row);
	
	if (func!="MECHANISM") {
//	var row=table.insertRow();
	var cell0=row.insertCell();
	var cell1=row.insertCell();
	var cell2=row.insertCell();

	if (func=="VAR") {
		cell0.innerHTML=getTxtStr(table.id, table.rows.length-2,3);
		cell1.innerHTML=getDelButStr(table.id, table.rows.length-2);
		cell0.childNodes[0].focus();
	}
	else if (func=="PREDICATE") {
		cell0.innerHTML=getTxtStr(table.id, table.rows.length-2,1);
		cell1.innerHTML=getDelButStr(table.id, table.rows.length-2);
		cell2.innerHTML=getModButStr(table.id, table.rows.length-2);
		cell0.childNodes[0].focus();
	}
	else if (func=="TAG"  || func=="BIND_VAR") {
		cell0.innerHTML=getTxtStr(table.id, table.rows.length-2,2);
		cell1.innerHTML=getDelButStr(table.id, table.rows.length-2);
		cell0.childNodes[0].focus();
	}
	else if (func=="CONFIG" || func=="PICK" || func=="CREDENTIAL") {
		cell0.innerHTML=getTxtStr(func, table.rows.length-2,4);
		cell1.innerHTML=getDelButStr(table.id, table.rows.length-2);
		cell0.childNodes[0].focus();
		
		if (modSetStr!="") modSetStr+=", ";
		modSetStr+= ((table.rows.length-2)+"-"+table.id+"/"+func);
	}
	}
	else { //func == "MECHANISM"

		//Create the mechansim row
		var cell0=row.insertCell();
		var cell1=row.insertCell();
		var cell2=row.insertCell();

		cell0.innerHTML=getTxtStr(table.id, table.rows.length-2,1);
		cell1.innerHTML=getDelButStr(table.id, table.rows.length-2);
		cell2.innerHTML=getModButStr(table.id, table.rows.length-2);
		cell0.childNodes[0].focus();
		
		//Creating header table
		var row1=document.createElement("TR");
		addLoc=table.rows[table.rows.length-1];
		addLoc.insertAdjacentElement("beforeBegin", row1);
		
		var subTable = document.createElement("TABLE");
		cell0=row1.insertCell();
		subTable.cellPadding=0;
		subTable.cellSpacing=0;
		subTable.width=430;
		
		var index=Math.floor((table.rows.length-2)/2);
		createHeaderTable(subTable, depth, "Mechanism Arguments", index);
		
		//Add to cell1
		cell0.colSpan=3;
		cell0.appendChild(subTable);
		
		//Add div to cell0
		var div=document.createElement("DIV");
		div.id="mydiv"+depth+"_"+index;
		
		//setting the style
		div.STYLE="overflow: auto; width: 430px; border-bottom: gray 1px solid; BORDER-LEFT: gray 1px solid; BORDER-RIGHT: gray 1px solid;";
		cell0.insertAdjacentElement("beforeEnd", div);

		//Insert a table inside the div
		var subTable1=document.createElement("TABLE");
		subTable1.id="mytable"+depth+"_"+index;
		subTable1.cellPadding=0;
		subTable1.cellSpacing=0;
		
		var col1=document.createElement("COL");
		var col2=document.createElement("COL");
		var col3=document.createElement("COL");
		col1.width=250;
		col2.width=100;
		col3.width=100;
		
		subTable1.appendChild(col1);
		subTable1.appendChild(col2);
		subTable1.appendChild(col3);
		
		row1=subTable1.insertRow();
		var cell3=row1.insertCell();
		div.appendChild(subTable1);
		
		//Add the new mechanism button in the table cell
		var subTable2=document.createElement("TABLE");
		row2=subTable2.insertRow();
		cell3=row2.insertCell();
		var cell4=row2.insertCell();
		cell3.width="50%";
		cell4.width="50%";
		
		var control=document.createElement("INPUT");
		control.type="BUTTON";
		control.value="NEW ARGUMENT";
		control.onclick="insert('VAR', '"+depth+"_"+index+"')" ;
		cell3.appendChild(control);
		
		div.insertAdjacentElement("beforeEnd", subTable2);
		
		//A line break
		cell3.innerHTML="<br>"+cell3.innerHTML+"<br><br>";
		cell0.innerHTML=cell0.innerHTML+"<br>";
	}
}

function createHeaderTable(table, depth, heading, index) {

	row=table.insertRow();
	
	cell1=row.insertCell();
	cell2=row.insertCell();
	cell3=row.insertCell();
	
	cell1.width=100;
	cell2.width=150;
	cell3.width=200;
	
	cell2.align="center";
	cell3.align="center";
	
	cell1.bgColor="6699CC";
	cell2.bgColor="6699CC";
	cell3.bgColor="6699CC";
	
	cell2.innerHTML="<b>"+heading+"</b>";
	cell3.innerHTML="<img src=\"Assets/Image/UI_OM_collapse.gif\" width='21' height='18' onclick='collapse(mydiv"+depth+"_"+index+")'/>";
	cell3.innerHTML+=" <img src=\"Assets/Image/UI_OM_expand.gif\" width='21' height='18' onclick='expand(mydiv"+depth+"_"+index+")'/> ";
}

function modifyRow (table, i) {
	var currow=table.rows[i];
	var string="";
	if (currow.cells[0].childNodes[0].childNodes[0]) 
		string=currow.cells[0].childNodes[0].childNodes[0].data;
	currow.cells[0].innerHTML="<input type='textarea' size='12' onblur='blurRow("+table.id+","+i+")' value='"+string+"'/>";
	currow.cells[0].childNodes[0].focus();
}

function blurRow(table, i) {
	var cell=table.rows[i].cells[0];
	
	if (modSetStr!="") modSetStr+=", ";
	modSetStr+= (i+"-"+table.id+"/"+cell.childNodes[0].value);

	table.rows[i].cells[0].innerHTML="<a>"+cell.childNodes[0].value+"</a>\n";	
}

//type
// 1 -- The one that will have the blur event
// 2 -- Just an empty text box
// 3 -- Assignment text boxes (2 text box with equal sign)
// 4 -- Just to display a particular string
// For 4 - id is the display, type is the link
function getTxtStr (id, rows, type) {
	if (type==1)
		return "<input type=\"textarea\" onblur='blurRow("+id+","+rows+")' name=\""+(rows)+"\" id=\""+(rows)+"\" value=\"\"/>";
	else if (type==2)
		return "<input id=textbox type=\"textarea\" name=\""+(rows)+"\" id=\""+(rows)+"\" value=\"\"/>";
	else if (type==3)
		return "<input id=textbox type=\"textarea\" size=\"10\" name=\""+(rows)+"\" id=\""+(rows)+"\" value=\"\"/> = <input type=\"textarea\" size=\"10\" name=\""+(rows)+"\" id=\""+(rows)+"\" value=\"\"/>";
	else if (type==4)
		return "<a>"+id+"</a>";
}

function getDelButStr (id, rows) {
	return "<input type=\"button\" value=\"Del\" onclick=\"deleteRow("+(id)+","+(rows)+")\"/>";
}
function getModButStr (id, rows) {
	return "<input type='button' name='Button' value='Modify' onclick='modifyRow("+(id)+","+(rows)+")'/>";
}

function sendRequest() {
	//Go through the table in the page. Data are stored in string form array.
	//[... .... ]
	//Only go through those that are not saved previously (text box)	
	var docArray=document.all;
	for (i=0; i<docArray.length; i++) {
		var id=docArray[i].id;
		var regEx=/mytable/;
		
		//test if the table contain subTable
		var testObj=document.getElementById(id+"_0");
		
		if (regEx.test(id) && testObj==null) {
			var table=docArray[i];
			
			//For each table
			for (j=0; j<table.rows.length; j++) {
				var row=table.rows[j];
				var node=row.cells[0].childNodes[0];
				
				if (node!=null && node.type=='text')
				{
					setStr +=(setStr.length>0?',':'')+table.id+"/"+node.value;
					if (row.cells[0].childNodes.length>2 && row.cells[0].childNodes[2].type=='text') 
						setStr+="%3D"+row.cells[0].childNodes[2].value;
				}
			}
		} else if (id=="reconfig"){
			var myEl=document.getElementById(id);
			if (myEl.checked) setStr +=(setStr.length>0?',':'')+ "reconfig/true"
			else setStr +=(setStr.length>0?',':'')+ "reconfig/false"
		}
	}
	//window.prompt("modSetStr", modSetStr);
	//window.prompt("setStr", setStr);
	
	var queryStr="request?action=GUI_update_RequestHandler&setStr="+setStr+"&modSetStr="+modSetStr;
	form1.action=queryStr;
	form1.submit();
}