package AntigoneUI.DB.requesthandlers;

import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

//Own application class
import AntigoneUI.*;
import AntigoneUI.DB.*;

public class DBLoginRequestHandler implements DBRequestHandler
{
	private Connection connection=null;
	private static final String queryStr="SELECT * FROM USER_PASSWD WHERE userid=?";
	
	//Need to initialize the db connection first before handling the request
	public void setConnection(Connection con) {
		connection=con;
	}
	
	public String handleRequest(HttpServletRequest request) throws AppException {
		if (connection==null) 
			throw new AppException("NULL DB connection in DBLoginRequestHandler.");
		
		//Getting the 2 parameters
		String userID=request.getParameter("UserID");
		
		System.out.println("DBLogin: "+request.getRemoteUser());
		
		//Execute the SQL statement.
		ResultSet rs=null;
		try {
			PreparedStatement preparedStatement = connection.prepareStatement(queryStr);
			preparedStatement.setString(1, userID);
			
			rs=preparedStatement.executeQuery();
		} catch (Exception e) {}
		
		try {
			if ( !rs.next() ) throw new AppException("UserID and Password not matched!");
		} catch (Exception e) {
			throw new AppException (e.getMessage());
		}
		
		HttpSession session=request.getSession();
		try {
			session.setAttribute("id", rs.getString("id"));
			session.setAttribute("user", rs.getString("userid"));
		} catch (Exception e) {}
		
		return ("/request?action=DB_userfile_RequestHandler");
	}
	
}