package AntigoneUI.DB.requesthandlers;

import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
import java.io.*;

//Own application class
import AntigoneUI.*;
import AntigoneUI.DB.*;

//Third party class
import org.apache.catalina.realm.*;

public class DB_registration_RequestHandler implements DBRequestHandler
{
	private Connection connection=null;
	private static final String queryStr1="SELECT * FROM USER_PASSWD WHERE userid=?";
	private static final String queryStr2="INSERT INTO USER_PASSWD (id, userid, password, association) VALUES (NULL, ?, ?, ?)";
	private static final String queryStr3="INSERT INTO USER_ROLE (userid, role) VALUES (?, ?)";
	//Need to initialize the db connection first before handling the request
	public void setConnection(Connection con) {
		connection=con;
	}
	
	public String handleRequest(HttpServletRequest request) throws AppException {
		if (connection==null)
			throw new AppException("NULL DB connection in DB_registration_RequestHandler.");
		
		//get the session
		HttpSession session=request.getSession();
		
		//getting all the parameter
		String userName=request.getParameter("username");
		String passwd=request.getParameter("passwd");
		String rePasswd=request.getParameter("re-passwd");
		String company=request.getParameter("company");
		
		//Check if the two passwords are the same.
		if (!passwd.equals(rePasswd)) {
			session.setAttribute("reg_ErrMsg", "The two password fields do not match!");
			return ("/register.jsp");
		}
		
		//Check if the userName have been used.
		ResultSet rs=null;
		try {
			PreparedStatement preparedStatement = connection.prepareStatement(queryStr1);
			preparedStatement.setString(1, userName);
			
			rs=preparedStatement.executeQuery();
		} catch (Exception e) {}
		
		try {
			if (rs.next()) {
				session.setAttribute("reg_ErrMsg", "The user name has already been registered. Please use another one.");
				return ("/register.jsp");
			}
		} catch (Exception e) {}
		
		//Finally add the entry into the database
			
		try {
			PreparedStatement preparedStatement = connection.prepareStatement(queryStr2);
			preparedStatement.setString(1, userName);
			
			//Using MD5 encryption
			preparedStatement.setString(2, RealmBase.Digest(passwd, "MD5"));
			preparedStatement.setString(3, company);
			
			PreparedStatement preparedStatement2 = connection.prepareStatement(queryStr3);
			preparedStatement2.setString(1, userName);
			preparedStatement2.setString(2, "AntigoneUI_User");
			
			rs=preparedStatement.executeQuery();
			rs=preparedStatement2.executeQuery();			
		} catch (Exception e) {System.out.println(e.getMessage());}
		
		//Creating a directory for that particular user
		String sep=File.separator;
		File newDir=new File(session.getServletContext().getRealPath(sep+"users"+sep+userName));
		
		try {
			System.out.println(newDir.getCanonicalPath() );
		} catch (Exception e) {}
		newDir.mkdir();
		
		return ("/thank.jsp");
	}
}