package AntigoneUI.DB.requesthandlers;

import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

//Own application class
import AntigoneUI.*;
import AntigoneUI.DB.*;

//Third party class
import org.apache.catalina.realm.*;

public class DB_updateAccount_RequestHandler implements DBRequestHandler
{
	private Connection connection=null;
	
	private static final String queryStr1="SELECT * FROM USER_PASSWD WHERE userid=?";
	private static final String queryStr2="UPDATE USER_PASSWD SET password=?, association=? WHERE userid=?";
	
	//Need to initialize the db connection first before handling the request
	public void setConnection(Connection con) {
		connection=con;
	}
	
	public String handleRequest(HttpServletRequest request) throws AppException {
		if (connection==null)
			throw new AppException("NULL DB connection in DB_registration_RequestHandler.");
		
		//get the session
		HttpSession session=request.getSession();
		
		//getting all the parameter
		String userName=(String) session.getAttribute("user");
		String passwd=request.getParameter("passwd");
		String newPasswd=request.getParameter("new-passwd");
		String rePasswd=request.getParameter("re-passwd");
		String company=request.getParameter("company");
		
		//Check if the two passwords are the same.
		if (!newPasswd.equals(rePasswd)) {
			session.setAttribute("up_ErrMsg", "The new password fields do not match!");
			return ("/updateAccount.jsp");
		}
		
		//Check if it match with the old password
		ResultSet rs=null;
		try {
			PreparedStatement preparedStatement = connection.prepareStatement(queryStr1);
			preparedStatement.setString(1, userName);
			
			rs=preparedStatement.executeQuery();
		} catch (Exception e) {}
		
		try {
			if (rs.next()) {
				String userPasswd=rs.getString("password");
				if (!userPasswd.equals( RealmBase.Digest(passwd, "MD5") )) {
					session.setAttribute("up_ErrMsg", "The password field do not match the one in the database!");
					return ("/updateAccount.jsp");
				}
			} else {
				session.setAttribute("up_ErrMsg", "Do not contain such user!");
				return ("/updateAccount.jsp");
			}
		} catch (Exception e) {}
		
		//Now add the new info into the database
		try {
			PreparedStatement preparedStatement = connection.prepareStatement(queryStr2);
			preparedStatement.setString(1, RealmBase.Digest(newPasswd, "MD5"));
			preparedStatement.setString(2, company);
			preparedStatement.setString(3, userName);
			
			rs=preparedStatement.executeQuery();
		} catch (Exception e) {}
		
			return("/request?action=DB_userfile_RequestHandler");
	}
}