package AntigoneUI.GUI.requesthandlers;

import AntigoneUI.GUI.*;
import AntigoneUI.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

//3rd party classes
import org.dom4j.*;
import org.dom4j.io.*;

public class GUI_openPolicy_RequestHandler implements GUIRequestHandler
{
	private final String SPECIALCODE="0xDEADBEEF";
	
	public String handleRequest (HttpServletRequest request) 
		throws AppException
	{
		//Get the ID that the user want to open
		HttpSession session=request.getSession();
		session.removeAttribute("attributeVec");
		String ID=request.getParameter("ID");
		
		//Save the user level in the tree
		session.setAttribute("userLevel", ID);
		File openFile=(File)session.getAttribute("openFile");
		
		StringTokenizer strtok=new StringTokenizer(ID, "/", false);
		String token=strtok.nextToken();

		if (token==null || !token.equals("root")) 
			throw new AppException("Tree not start with a right node.");
		
		if (strtok.hasMoreTokens()) token=strtok.nextToken().trim();
		else token=null;
		
		if (token==null) {
			Vector allVec=handleAllVec(openFile);
			
			session.setAttribute("displayVec", allVec);
			return ("/JspSupport/policyItemView.jsp");
		} else if (token.equals("attribute") ) {
			//Using vector as the way of communication between JSP and the server
			Vector attributeVec=handleAttribute(strtok, openFile);
			session.setAttribute("attributeVec", attributeVec);
			
			if ( (attributeVec.get(0) instanceof String) &&  ((String)attributeVec.get(0)).equals(SPECIALCODE) ) 
				return ("/JspSupport/attributeTopView.jsp");
			else return ("/JspSupport/attributeView.jsp");
		} else if (token.equals("provisional")) {
			Vector provisionVec=handleProvision(strtok,openFile);

			//making all the empty attribute as null
			/*
			for (int i=0;i<provisionVec.size();i+=2) {
				if (provisionVec.size()==0) break;
				Vector testVec= (Vector) provisionVec.get(i+1);
				if (testVec.size()==0) {
					provisionVec.remove(i);
					provisionVec.remove(i);
					i-=2;
				}
			}
			*/
			//System.out.println("After deletion");
			//System.out.println(provisionVec);

			session.setAttribute("displayVec", provisionVec);
			return ("/JspSupport/policyItemView.jsp");
		} else if (token.equals("action")) {
			Vector actionVec=handleAction(strtok,openFile);
			session.setAttribute("displayVec", actionVec);
			return ("/JspSupport/policyItemView.jsp");
		} else throw new AppException("Address not support by OpenPolicy");
	}
	
	private Vector handleAction(StringTokenizer strtok, File xmlFile)
		throws AppException
	{
		//Open and read the XML file.		
		Document document=null;
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(xmlFile);
		} catch (Exception e) {
			System.out.println("Cannot read xmlFile.");
		}

		Element element=document.getRootElement();

		String name=null;
		while (strtok.hasMoreTokens() ) {
			//traversing to the right node in the XML file
			String token=strtok.nextToken();
			
			int loop=0;
			//Extracting the number
			for (int i=token.length()-1; i>=0; i--) {
				if (token.charAt(i)<'0' || token.charAt(i)>'9') {
					loop=Integer.parseInt(token.substring(i+1));
					name=token.substring(0, i+1);
					break;
				}
			}
			
			//System.out.println(name+" "+loop);
			
			if (name.equals("provision")) {
				Element test=null;
				/*
				try {
					(new XMLWriter(System.out)).write(element);
				} catch (Exception e) {
					System.out.println(e.getMessage());
				}*/
				
				Iterator it=element.elementIterator("predicate");
				for (int i=0;  (it.hasNext() && i<=loop); i++) 
					test=(Element) it.next();
				element=test;
			} else {
				String addr=null;
				if (name.equals("clause")) addr="action";
				else if (!name.equals("provision")) addr=name; //pick, config
				
				XPath xpath= DocumentHelper.createXPath(addr+"["+(loop+1)+"]");
				element=(Element) xpath.selectSingleNode(element);
			}
		}
		
		Vector vec=getActionDisplayVector(element ,name);
		return vec;
	}
	
	private Vector getActionDisplayVector(Element element ,String name) 
		throws AppException
	{
		Vector vec=new Vector();
		
		if (name==null) {
			vec.add("Actions");
			Vector policyVec=new Vector();
			vec.add(policyVec);
			for (Iterator i=element.elementIterator("action"); i.hasNext();) {
				Element child=(Element) i.next();
				String val=child.attributeValue("tag");
				policyVec.addElement(new GUIDisplayItem(val, "", GUIDisplayItem.LINK));
			}
			
			//Create the button element
			policyVec.addElement( new GUIButtonItem("NEW ACTION", "PREDICATE"));
		} else if (name.equals("clause")) {
			Vector cpVec=new Vector();
			Vector predicateVec=new Vector();
			Vector credentialVec=new Vector();
			
			vec.add("Predicates");
			vec.add(predicateVec);
			vec.add("Configs & Picks");
			vec.add(cpVec);
			vec.add("Credentials");
			vec.add(credentialVec);
			
			Iterator it=element.elementIterator();

			//Building the three vectors
			for (Iterator i=element.elementIterator(); i.hasNext();) {
				Element child=(Element) i.next();
				if (child.getName().equals("predicate"))
					predicateVec.addElement(new GUIDisplayItem(child.attributeValue("name"), "", GUIDisplayItem.LINK));
				else if (child.getName().equals("var"))
					predicateVec.addElement(new GUIDisplayItem(child.attributeValue("name"), child.attributeValue("value"), GUIDisplayItem.NAMEVALUE));
				else if (child.getName().equals("config") || child.getName().equals("pick"))
					cpVec.addElement(new GUIDisplayItem(child.getName().toUpperCase(), "", GUIDisplayItem.FIXEDLINK));
				else if (child.getName().equals("credential")) 
					credentialVec.add(new GUIDisplayItem(child.getName().toUpperCase(), "", GUIDisplayItem.FIXEDLINK));
			}
			
			//Building the button vectors of the three vectors
			predicateVec.addElement( new GUIButtonItem("INSERT VAR", "VAR"));
			predicateVec.addElement( new GUIButtonItem("INSERT PREDICATE", "PREDICATE"));
			
			cpVec.addElement( new GUIButtonItem("INSERT PICK", "PICK"));
			cpVec.addElement( new GUIButtonItem("INSERT CONFIG", "CONFIG"));

			credentialVec.addElement( new GUIButtonItem("INSERT CREDENTIAL", "CREDENTIAL"));
			
			//Adding the reconfig option
			vec.add(new GUIDisplayItem("Reconfig", element.attributeValue("reconfig"), 3));
			
		} else if (name.equals("provision")) {
			vec=getProvisionDisplayVector(element, "predicate");
		}
		else if (name.equals("config")) vec=getProvisionDisplayVector(element, "config");
		else if (name.equals("pick")) vec=getProvisionDisplayVector(element, "pick");
		else if (name.equals("mechanism")) vec=getProvisionDisplayVector(element, "mechanism");
		else if (name.equals("credential")) {
			Vector bindVec=new Vector();
			Vector credVec=new Vector();
			
			vec.add("Bind Variable");
			vec.add(bindVec);
			vec.add("Credential Arguments");
			vec.add(credVec);
			
			XPath xpath= DocumentHelper.createXPath("bindvar[1]");
			Element child=(Element) xpath.selectSingleNode(element);
			
			if (child!=null) bindVec.add(new GUIDisplayItem((String) child.attributeValue("name"), "", GUIDisplayItem.TEXT));
			bindVec.add(new GUIButtonItem("NEW BIND VAR", "BIND_VAR"));
			
			for (Iterator it=element.elementIterator(); it.hasNext();) {
				Element subChild=(Element) it.next();
				if (subChild.getName().equals("cred_arg")) {
					//String value=subChild.attributeValue("value");
					credVec.add(new GUIDisplayItem(subChild.attributeValue("name") ,subChild.attributeValue("value"), GUIDisplayItem.NAMEVALUE));
				}
			}
			
			credVec.add(new GUIButtonItem("NEW CRED. ARGUMENT", "VAR"));
		}
		//System.out.println(vec);
		return vec;
	}

	private Vector handleAllVec(File xmlFile) 
		throws AppException
	{
		//Open and read the XML file.		
		Document document=null;
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(xmlFile);
		} catch (Exception e) {
			System.out.println("Cannot read xmlFile.");
		}

		Element element=document.getRootElement();
		
		Vector subAttrVec=new Vector();
		
		for (Iterator it=element.elementIterator("attribute"); it.hasNext(); subAttrVec.addElement(new GUIDisplayItem(((Element) it.next()).attributeValue("tag"), "", GUIDisplayItem.LINK)));
		subAttrVec.addElement(new GUIButtonItem("INSERT ATTRIBUTE", "PREDICATE"));

		Vector provisionVec=handleProvision(new StringTokenizer("", "/", false),xmlFile);
		Vector actionVec=handleAction(new StringTokenizer("", "/", false), xmlFile);
		
		Vector myVec=new Vector();
		myVec.addElement ("Attribute Sets");
		myVec.addElement(subAttrVec);
		myVec.addElement((String)provisionVec.get(0));
		myVec.addElement((Vector)provisionVec.get(1));
		myVec.addElement((String)actionVec.get(0));
		myVec.addElement((Vector)actionVec.get(1));
		
		return myVec;
	}
	
	private Vector handleProvision(StringTokenizer strtok, File xmlFile)
		throws AppException
	{
		//Open and read the XML file.
		
		Document document=null;
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(xmlFile);
		} catch (Exception e) {
			System.out.println("Cannot read xmlFile.");
		}
		
		Element element=document.getRootElement();
		
		String name=null;
		while (strtok.hasMoreTokens() ) {
			//traversing to the right node in the XML file
			String token=strtok.nextToken();

			int loop=0;
			//Extracting the number
			for (int i=token.length()-1; i>=0; i--) {
				if (token.charAt(i)<'0' || token.charAt(i)>'9') {
					loop=Integer.parseInt(token.substring(i+1));
					name=token.substring(0, i+1);
					break;
				}
			}
			
			//System.out.println(name+" "+loop);
			
			Iterator it=null;
			
			if (!name.equals("predicate") && !name.equals("mechanism") ) {
				if (name.equals("clause")) it=element.elementIterator("provision");
				else it=element.elementIterator(name); //pick, config
				Element target=(Element) it.next();
				for (int i=0;i<loop; i++) target=(Element) it.next();
				element=target;
			}
			else {//Conditional predicate
				if (name.equals("predicate")) it=element.elementIterator("predicate");
				if (name.equals("mechanism")) it=element.elementIterator("mechanism");
				
				Element child=null;
				for (int i=0; (it.hasNext() && i<=loop); i++) 
					child=(Element) it.next();
				element=(Element) child;
			}
		}
		
		Vector vec=getProvisionDisplayVector(element ,name);
		return vec;
	}
	
	private Vector getProvisionDisplayVector(Element element, String state) 
		throws AppException
	{
		Vector vec=new Vector();

		if (state==null) {
			vec.add("provision");
			Vector policyVec=new Vector();
			vec.add(policyVec);
			for (Iterator i=element.elementIterator("provision"); i.hasNext();) {
				Element child=(Element) i.next();
				String val=child.attributeValue("tag");
				policyVec.addElement(new GUIDisplayItem(val, "", GUIDisplayItem.LINK));
			}
			
			//Create the button element
			policyVec.addElement( new GUIButtonItem("NEW PROVISION", "PREDICATE"));
		}
		else if (state.equals("clause")) {
			Vector conditionVec=new Vector();
			Vector conseqVec=new Vector();
			Vector policyVec=new Vector();
			vec.add("Conditional statement");
			vec.add(conditionVec);
			vec.add("Consequence statement");
			vec.add(conseqVec);
			vec.add("Policy statement");
			vec.add(policyVec);
			
			//Building the three vectors
			for (Iterator i=element.elementIterator(); i.hasNext();) {
				Element child=(Element) i.next();
				if (child.getName().equals("predicate"))
					conditionVec.addElement(new GUIDisplayItem(child.attributeValue("name"), "", GUIDisplayItem.LINK));
				else if (child.getName().equals("var")) 
					conditionVec.addElement(new GUIDisplayItem(child.attributeValue("name"), child.attributeValue("value"), GUIDisplayItem.NAMEVALUE));
				else if (child.getName().equals("config") || child.getName().equals("pick"))
					conseqVec.addElement(new GUIDisplayItem(child.getName().toUpperCase(), "", GUIDisplayItem.FIXEDLINK));
				else if (child.getName().equals("policy")) 
					policyVec.add(new GUIDisplayItem(child.attributeValue("name"), "", GUIDisplayItem.TEXT));
			}
			
			//Building the button vectors of the three vectors
			conditionVec.addElement( new GUIButtonItem("INSERT VAR", "VAR"));
			conditionVec.addElement( new GUIButtonItem("INSERT PREDICATE", "PREDICATE"));
			
			conseqVec.addElement( new GUIButtonItem("INSERT PICK", "PICK"));
			conseqVec.addElement( new GUIButtonItem("INSERT CONFIG", "CONFIG"));

			policyVec.addElement( new GUIButtonItem("INSERT TAG", "TAG"));
		}
		else if (state.equals("predicate")) {
			
			//System.out.println("Reaching predicate");
			vec.addElement("Predicate Arguments");
			Vector argVec=new Vector();
			vec.addElement(argVec);
			
			for (Iterator i=element.elementIterator();i.hasNext();) {
				Element child=(Element) i.next();
				argVec.addElement(new GUIDisplayItem(child.attributeValue("value"), "", GUIDisplayItem.TEXT) );
			}
			
			//Creating the new button element
			argVec.addElement( new GUIButtonItem("NEW ARGUMENT", "TAG"));
			
		}
		else if (state.equals("config")) {
			vec.addElement("Config Mechanisms");
			Vector configVec=new Vector();
			vec.add(configVec);
			
			for (Iterator i=element.elementIterator();i.hasNext();) { //for each mechanism
				Element child=(Element) i.next();
				configVec.add(new GUIDisplayItem(child.attributeValue("name"), "", GUIDisplayItem.LINK) );
				configVec.add(getProvisionDisplayVector(child, "mechanism"));
			}
			
			//Creating the new button element
			configVec.addElement( new GUIButtonItem("NEW MECHANISM", "MECHANISM"));
			
		}
		else if (state.equals("pick")) {
			vec.addElement("Config Statements");
			Vector configVec=new Vector();
			vec.add(configVec);
			
			for (Iterator i=element.elementIterator();i.hasNext();) { //for each config
				Element child=(Element) i.next();
				configVec.add(new GUIDisplayItem("CONFIG", "", GUIDisplayItem.FIXEDLINK) );
			}
			
			//Creating the new button element
			configVec.addElement( new GUIButtonItem("INSERT CONFIG", "CONFIG"));
		}
		else if (state.equals("mechanism")) {
			vec.addElement("Mechanism Arguments");
			Vector argVec=new Vector();
			vec.addElement(argVec);
			
			for (Iterator i=element.elementIterator();i.hasNext();) {
				Element child=(Element) i.next();
				argVec.addElement(new GUIDisplayItem(child.attributeValue("name"), child.attributeValue("value")  , GUIDisplayItem.NAMEVALUE) );
			}
			
			//Creating the new button element
			argVec.addElement( new GUIButtonItem("NEW ARGUMENT", "VAR"));
			
		}
		else throw new AppException("Unexpected provision state.");
		return vec;
	}
	
	private Vector handleAttribute(StringTokenizer strtok, File xmlFile) 
	{
		//Open and read the XML file.
		Document document=null;
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(xmlFile);
		} catch (Exception e) {
			System.out.println("Cannot read xmlFile.");
		}
		
		Element element=document.getRootElement();
		
		while (strtok.hasMoreTokens() ) {
			//traversing to the right node in the XML file
			String token=strtok.nextToken();
			
			String name=null;
			int loop=0;
			//Extracting the number
			for (int i=token.length()-1; i>=0; i--) {
				if (token.charAt(i)<'0' || token.charAt(i)>'9') {
					loop=Integer.parseInt(token.substring(i+1));
					name=token.substring(0, i+1);
					break;
				}
			}

			Iterator it=null;
			if (name.equals("tag")) it=element.elementIterator("attribute");
			else it=element.elementIterator("set");

			Element target=(Element) it.next();
			for (int i=0;i<loop; i++) target=(Element) it.next();
			element=target;
		}
		
		if (element==document.getRootElement() ) {
			//At the attribute highest level
			Vector vec=new Vector();
			vec.addElement(SPECIALCODE);
			for (Iterator i=element.elementIterator("attribute"); i.hasNext();) {
				Element child=(Element) i.next();				
				String val=child.attributeValue("tag");
				vec.addElement(val);
			}
			return vec;
			
		} else {
			//Reaching the required level			
			Vector vec=new Vector();
			
			for (Iterator i=element.elementIterator("param"); i.hasNext(); ) {
				Element child=(Element) i.next();
				String val=child.attributeValue("value");
				vec.addElement(val);
			}
			int size=element.elements("set").size();
			vec.addElement(new Integer(size));
			return vec;
		}
	}
}