package AntigoneUI.GUI.requesthandlers;

import AntigoneUI.GUI.*;
import AntigoneUI.*;

import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

//3rd party classes
import org.dom4j.*;
import org.dom4j.io.*;

public class GUI_update_RequestHandler implements GUIRequestHandler
{
	public String handleRequest (HttpServletRequest request) 
		throws AppException
	{
		//Get the Page attributes
		HttpSession session=request.getSession();
		File openFile=(File)session.getAttribute("openFile"); //an xml file
		session.setAttribute("TreeUpdated", "1");
		String userLevel=(String) session.getAttribute("userLevel");

		//For testing purpose
		/*
		Enumeration paramIt=request.getParameterNames();
		while (paramIt.hasMoreElements()) {
			String paramStr=(String) paramIt.nextElement();
			
			System.out.print(paramStr+" = ");
			String [] parArray=request.getParameterValues(paramStr);
			for (int i=0;i<parArray.length;i++) {
				System.out.print((i==0?"":", ")+parArray[i]+"   ");
			}
			System.out.println("");
		}
		System.out.println(userLevel+"--- END\n");
		*/
		
		StringTokenizer strtok=new StringTokenizer(userLevel, "/", false);
		
		String token=strtok.nextToken();
		if (token==null || !token.equals("root")) 
			throw new AppException("Tree not start with a right node.");
		
		if (strtok.hasMoreTokens()) token=strtok.nextToken();
		else token=null;
			
		if (token==null) {
			handleAll(strtok,openFile, request.getParameterMap());
			return ("/request?action=GUI_showFile_RequestHandler");
		} else if (token.equals("attribute") ) {
			//Using vector as the way of communication between JSP and the server
			handleAttribute(strtok, openFile, request.getParameterMap());
			return ("/request?action=GUI_showFile_RequestHandler");
		} else if (token.equals("provisional")) {
			handleProvision(strtok, openFile, request.getParameterMap());
			return ("/request?action=GUI_showFile_RequestHandler");
		} else if (token.equals("action")) {
			handleAction(strtok, openFile, request.getParameterMap());
			return ("/request?action=GUI_showFile_RequestHandler");
		}
		else throw new AppException ("No valid action found --- GUI_update_RequestHandler");
	}
	
	private void handleAction(StringTokenizer strtok, File xmlFile, Map paramMap)
		throws AppException
	{
		//Open and read the XML file.
		Document document=null;
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(xmlFile);
		} catch (Exception e) {
			System.out.println("Cannot read xmlFile.");
		}
		
		//Reaching the required level
		Element element=document.getRootElement();
		String name=null;
		while (strtok.hasMoreTokens()) {
			String token=strtok.nextToken();
			
			//Extracting the number
			int loop=0;
			for (int i=token.length()-1; i>=0; i--) {
				if (token.charAt(i)<'0' || token.charAt(i)>'9') {
					loop=Integer.parseInt(token.substring(i+1));
					name=token.substring(0, i+1);
					break;
				}
			}
			
			if (name.equals("clause")) name="action";
			
			XPath xpath=null;
			if (!name.equals("provision")) 
				xpath= DocumentHelper.createXPath(name+"["+(loop+1)+"]");
			else xpath= DocumentHelper.createXPath("predicate["+(loop+1)+"]");
			element=(Element) xpath.selectSingleNode(element);
		}
		
		//Do the appropriate thing now at the appropriate level
		//0-mytable_0/init
		String mStr=((String[]) paramMap.get("modSetStr"))[0];
		String[] strArray=(String[]) paramMap.get("setStr");
		String sStr=strArray[0];
		
		StringTokenizer strtok2=new StringTokenizer (mStr, ",", false);
		
		while (strtok2.hasMoreTokens()) {
			String token=strtok2.nextToken().trim();
			
			String row=token.substring(0, token.indexOf("-"));
			String tableStr=token.substring(token.indexOf("-")+1, token.lastIndexOf("/"));
			String value=token.substring(token.lastIndexOf("/")+1);
			
			
			
			//System.out.println(name);
			//System.out.println(row);
			//System.out.println(tableStr);
			//System.out.println(value);
			
			
			int rowVal=Integer.parseInt(row);
			
			Element child=null;
			if (name==null) {
				XPath xpath= DocumentHelper.createXPath("action["+(rowVal+1)+"]");
				child=(Element) xpath.selectSingleNode(element);
				
				if (child!=null) {
					if (!value.equals("delete")) child.addAttribute("tag", value);
					else element.remove(child);
				}
				else {
					Element newEl=element.addElement("action");
					newEl.addAttribute("tag", value);
					newEl.addAttribute("reconfig", "false");
				}
			} else if (name.equals("action")) {
				if (tableStr.equals("mytable_0")) {
					
					Element subChild=null;
					for (Iterator it=element.elementIterator(); it.hasNext();) {
						Element tmp=(Element) it.next();
						if (tmp.getName().equals("var") || tmp.getName().equals("predicate")) {
							if (rowVal!=0) rowVal--;
							else {
								subChild=tmp;
								break;
							}
						}
					}
					
					if (subChild!=null) {
						if (!value.equals("delete")) subChild.addAttribute("name", value);
						else element.remove(subChild);
					}
					else {
						Element childEl=element.addElement("predicate");
						childEl.addAttribute("name", value);
					}
				} else if (tableStr.equals("mytable_1")) {
					child=null;
					for (Iterator it=element.elementIterator(); it.hasNext();) {
						Element tmp=(Element) it.next();
						if (tmp.getName().equals("config") || tmp.getName().equals("pick")) {
							if (rowVal!=0) rowVal--;
							else {
								child=tmp;
								break;
							}
						}
					}
					//XPath xpath= DocumentHelper.createXPath("pick|config ["+(rowVal+1)+"]");
					//System.out.println("(config|pick)"+"["+(rowVal+1)+"]");
					//child=(Element) xpath.selectSingleNode(element);
					
					//System.out.println(child);
					
					if (child!=null) element.remove(child);
					else element.addElement(value.toLowerCase());
				} else if (tableStr.equals("mytable_2")) {
					XPath xpath= DocumentHelper.createXPath("credential"+"["+(rowVal+1)+"]");
					child=(Element) xpath.selectSingleNode(element);
					if (child==null) element.addElement(value.toLowerCase());
					else element.remove(child);
				}
			} else if (name.equals("pick")) {
				if (!value.equals("delete")) element.addElement(value.toLowerCase());
				else {
					XPath xpath= DocumentHelper.createXPath("config["+(rowVal+1)+"]");
					Node childNode=xpath.selectSingleNode(element);
					element.remove(childNode);
				}
			} else if (name.equals("config")) {
				rowVal/=2;
				
				//goto the right node first
				Element target=null;
				for (Iterator it=element.elementIterator(); it.hasNext();) {
					Element traverse=(Element) it.next();
					if (traverse.getName().equals("mechanism")) {
						if (rowVal!=0) rowVal--;
						// The right parent node
						else {
							target=traverse;
							break;
						}
					}
				}
				
				if (value.equals("delete")) element.remove(target);
				else if (target==null) {
					Element childEl=element.addElement("mechanism");
					childEl.addAttribute("name", value);
				}
				else target.addAttribute("name", value);
			}
		}
		
		//Handling setString
		strtok2=new StringTokenizer (sStr, ",", false);
		
		//Deleting the set
		Vector myVec=new Vector();
		
		if (name!=null) {
			
			if (name.equals("action")) {
				for (Iterator it=element.elementIterator("var");it.hasNext(); myVec.add((Element)it.next() ));
				for (int i=0; i<myVec.size(); i++) element.remove((Element) myVec.get(i));
			}
			else if (name.equals("config")) {
				for (Iterator it=element.elementIterator();it.hasNext();) {
					Element myEl=(Element) it.next();
					myVec=new Vector();
					for (Iterator tmpIt=myEl.elementIterator(); tmpIt.hasNext(); myVec.add((Element)tmpIt.next() ));
					for (int i=0; i<myVec.size(); i++) myEl.remove((Element) myVec.get(i));
				}
			} else if (name.equals("provision")) {
				for (Iterator it=element.elementIterator("param");it.hasNext(); myVec.add((Element)it.next() ));
				for (int i=0; i<myVec.size(); i++) element.remove((Element) myVec.get(i));
			}else if (name.equals("credential")) {
				for (Iterator it=element.elementIterator();it.hasNext(); myVec.add((Element)it.next() ));
				for (int i=0; i<myVec.size(); i++) element.remove((Element) myVec.get(i));
			} else if (name.equals("mechanism")) {
				for (Iterator it=element.elementIterator();it.hasNext(); myVec.add((Element)it.next()));
				for (int i=0; i<myVec.size(); i++) element.remove((Element) myVec.get(i));
			}
		}
		
		//Adding the new set
		while (strtok2.hasMoreTokens() ) {
			String token=strtok2.nextToken().trim();
			String tableStr=token.substring(0, token.lastIndexOf("/"));
			String value=token.substring(token.lastIndexOf("/")+1);
		
			//System.out.println(name);
			//System.out.println(tableStr);
			//System.out.println(value);			
			
			if (name.equals("action")) {
				if (tableStr.equals("mytable_0")) {
					String varName=value.substring(0, value.lastIndexOf("="));
					String varValue=value.substring(value.lastIndexOf("=")+1);
					
					Element newEl=element.addElement("var");
					newEl.addAttribute("name", varName);
					newEl.addAttribute("value", varValue);
				}
				
				if (tableStr.equals("reconfig")) {
					if (value.equals("true")) element.addAttribute("reconfig", "true");
					else element.addAttribute("reconfig", "false");
				}
			} else if (name.equals("provision")) {
				if (tableStr.equals("mytable_0")) {
					Element newEl=element.addElement("param");
					newEl.addAttribute("value", value);
				}
			} else if (name.equals("config")) {
				String varName=value.substring(0, value.lastIndexOf("="));
				String varValue=value.substring(value.lastIndexOf("=")+1);
				
				int rowVal=Integer.parseInt(tableStr.substring(tableStr.lastIndexOf("_")+1));
				XPath xpath= DocumentHelper.createXPath("*["+(rowVal+1)+"]");
				Element myEl=(Element) xpath.selectSingleNode(element);				
				Element newEl=myEl.addElement("mechParam");
				newEl.addAttribute("name", varName);
				newEl.addAttribute("value", varValue);
				
			} else if (name.equals("credential")) {
				//mytable_0/$cert,mytable_1/iss%3D$issuer
				if (tableStr.equals("mytable_0")) {
					Element myEl=element.addElement("bindvar");
					myEl.addAttribute("name", value);
				} else {
					String varName=value.substring(0, value.lastIndexOf("="));
					String varValue=value.substring(value.lastIndexOf("=")+1);
					
					Element myEl=element.addElement("cred_arg");
					myEl.addAttribute("name", varName);
					myEl.addAttribute("value", varValue);
				}
			} else if (name.equals("mechanism")) {
				String varName=value.substring(0, value.lastIndexOf("="));
				String varValue=value.substring(value.lastIndexOf("=")+1);
				
				Element newEl=element.addElement("mechParam");
				newEl.addAttribute("name", varName);
				newEl.addAttribute("value", varValue);
			}
		}
		
		writeXmlFile(xmlFile, document);
	}
	
	private void handleAll(StringTokenizer strtok, File xmlFile, Map paramMap) 
		throws AppException
	{
		//Open and read the XML file.
		Document document=null;
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(xmlFile);
		} catch (Exception e) {
			System.out.println("Cannot read xmlFile.");
		}
		
		//Reaching the required level
		Element element=document.getRootElement();
		String mStr=((String[]) paramMap.get("modSetStr"))[0];
		
		StringTokenizer strtok2=new StringTokenizer(mStr, ",", false);
		
		while (strtok2.hasMoreTokens() ) {
			String token=strtok2.nextToken().trim();
			
			String row=token.substring(0, token.indexOf("-"));
			String tableStr=token.substring(token.indexOf("-")+1, token.lastIndexOf("/"));
			String value=token.substring(token.lastIndexOf("/")+1);
			
			int rowVal=Integer.parseInt(row);
			
			String addr=null;
			if (tableStr.equals("mytable_0")) addr="attribute";
			else if (tableStr.equals("mytable_1")) addr="provision";
			else if (tableStr.equals("mytable_2")) addr="action";
			
			XPath xpath= DocumentHelper.createXPath(addr+"["+(rowVal+1)+"]");
			Node childNode=xpath.selectSingleNode(element);
			if (childNode==null) { //Adding a new provision
				Element myEl=element.addElement(addr);
				myEl.addAttribute("tag", value);
				if (addr.equals("action")) myEl.addAttribute("reconfig", "false");
			}
			else if (!value.equals("delete")) ((Element)childNode).addAttribute("tag", value);
			else element.remove(childNode);
		}
		
		writeXmlFile(xmlFile, document);
	}
	
	private void handleProvision(StringTokenizer strtok, File xmlFile, Map paramMap) 
		throws AppException
	{
		//Open and read the XML file.
		Document document=null;
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(xmlFile);
		} catch (Exception e) {
			System.out.println("Cannot read xmlFile.");
		}
		
		//Reaching the required level
		Element element=document.getRootElement();
		
		String name=null;
		while (strtok.hasMoreTokens() ) {
			//traversing to the right node in the XML file
			String token=strtok.nextToken();
			
			int loop=0;
			//Extracting the number
			for (int i=token.length()-1; i>=0; i--) {
				if (token.charAt(i)<'0' || token.charAt(i)>'9') {
					loop=Integer.parseInt(token.substring(i+1));
					name=token.substring(0, i+1);
					break;
				}
			}
			
			Iterator it=null;
			if (name.equals("clause")) it=element.elementIterator("provision");
			else if (name.equals("config")) it=element.elementIterator("config");
			else if (name.equals("pick")) it=element.elementIterator("pick");
			else if (name.equals("mechanism")) it=element.elementIterator();
			else if (name.equals("predicate")) it=element.elementIterator("predicate");
			
			if (it!=null) {
				Element target=(Element) it.next();
				for (int i=0;i<loop; i++) target=(Element) it.next();
				element=target;
			}
		}
		
		String sStr=((String[]) paramMap.get("setStr"))[0];
		String mStr=((String[]) paramMap.get("modSetStr"))[0];

		//Reaching the required level
		if (name==null) { //At the provisional level
			StringTokenizer strtok2=new StringTokenizer(mStr, ",", false);
			
			while (strtok2.hasMoreTokens() ) {
				String token=strtok2.nextToken().trim();
				
				String row=token.substring(0, token.indexOf("-"));
				String tableStr=token.substring(token.indexOf("-")+1, token.lastIndexOf("/"));
				String value=token.substring(token.lastIndexOf("/")+1);
				
				int rowVal=Integer.parseInt(row);

				XPath xpath= DocumentHelper.createXPath("provision["+(rowVal+1)+"]");
				Node childNode=xpath.selectSingleNode(element);
				if (childNode==null) { //Adding a new provision
					Element myEl=element.addElement("provision");
					myEl.addAttribute("tag", value);
				}
				else if (!value.equals("delete")) ((Element)childNode).addAttribute("tag", value);
				else element.remove(childNode);
			}
			
		} else if (name.equals("clause")) {
			//do the modSetStr
			StringTokenizer strtok2=new StringTokenizer(mStr, ",", false);
			String token=null;
			
			Element child=null;
			
			//modSetStr:
			//1-mytable_0/aaa, 1-mytable_0/aaabbb, 2-mytable_0/qqq, 2-mytable_0/delete, 0-mytable_2/PICK, 1-mytable_2/PICK, 2-mytable_2/CONFIG, 1-mytable_2/delete
		
			for (; strtok2.hasMoreTokens();) {
				token=strtok2.nextToken().trim();
				
				String row=token.substring(0, token.indexOf("-") );
				String tableStr=token.substring(token.indexOf("-")+1, token.lastIndexOf("/"));
				String value=token.substring(token.lastIndexOf("/")+1);
				
				int rowVal=Integer.parseInt(row);
				
				if (tableStr.equals("mytable_0")) {
					Element target=null;
					
					Iterator it=element.elementIterator();
					while (it.hasNext() && target==null) {
						child=(Element) it.next();
						
						if (child.getName().equals("var") || child.getName().equals("predicate")) {
							if (rowVal==0) {
								target=child;
								break;
							}
							else rowVal--;
						}
					}

					if (target==null) {
						//Adding a new node
						Element childEl=element.addElement("predicate");
						childEl.addAttribute("name", value);
					}
					else {
						//modifying node
						if (!value.equals("delete")) target.addAttribute("name", value);
						else element.remove(target);
					}
				} else if (tableStr.equals("mytable_1")) {
					if (!value.equals("delete")) element.addElement(value.toLowerCase());
					else {
						Element childNode=null;
						for (Iterator it=element.elementIterator(); it.hasNext();) {
							Element tmp=(Element) it.next();
							if (tmp.getName().equals("config") || tmp.getName().equals("pick")) {
								if (rowVal!=0) rowVal--;
								else {
									childNode=tmp;
									break;
								}
							}
						}
						
						element.remove(childNode);
					}
				}
			}
/*			
		try {
			(new XMLWriter(System.out)).write(element);
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
*/
		//setStr:
		//mytable_0/aaa=bbb, mytable_4/timekey, mytable_4/weakconf, mytable_4/failstop
		//System.out.println(sStr);		
		Vector childVec=new Vector();

			//Delete the set first
			for (Iterator it=element.elementIterator("var"); it.hasNext(); childVec.add((Element) it.next()) );
			for (int i=0; i<childVec.size(); i++) {
				child=(Element)childVec.get(i);
				element.remove(child);
			}
			
			childVec=new Vector();
			for (Iterator it=element.elementIterator("policy"); it.hasNext(); childVec.add((Element) it.next()) ); 
			for (int i=0; i<childVec.size(); i++) {
				child=(Element)childVec.get(i);
				element.remove(child);
			}
			
			strtok2=new StringTokenizer(sStr, ",", false);
			while (strtok2.hasMoreTokens() ) {
				token=strtok2.nextToken().trim();
				
				StringTokenizer strtok3=new StringTokenizer (token, "/", false);				
				String tableStr=strtok3.nextToken();
				String value=strtok3.nextToken();				
				
				if (tableStr.equals("mytable_0")) {
					name=value.substring(0, value.indexOf("="));
					String param=value.substring(value.indexOf("=")+1);
					
					Element childEl=element.addElement("var");
					childEl.addAttribute("name", name);
					childEl.addAttribute("value", param);
				}
				else if (tableStr.equals("mytable_2")) {
					Element childEl=element.addElement("policy");
					childEl.addAttribute("name", value);
				}
			}
			
		} else if (name.equals("config")) {
			//do the modSetStr
			StringTokenizer strtok2=new StringTokenizer(mStr, ",", false);
			String token=null;
			
			//modSetStr:
			//2-mytable_0/delete, 1-mytable_2/PICK
			for (; strtok2.hasMoreTokens();) {
				token=strtok2.nextToken().trim();
				
				String row=token.substring(0, token.indexOf("-") );
				String tableStr=token.substring(token.indexOf("-")+1, token.lastIndexOf("/"));
				String value=token.substring(token.lastIndexOf("/")+1);
				
				int rowVal=Integer.parseInt(row)/2;
				
				//goto the right node first
				Element target=null;
				
				Iterator it=element.elementIterator();
				while (it.hasNext()) {
					Element traverse=(Element) it.next();
					if (traverse.getName().equals("mechanism")) {
						if (rowVal!=0) rowVal--;
						// The right parent node
						else {
							target=traverse;
							break;
						}
					}
				}
			
				if (value.equals("delete")) element.remove(target);
				else if (target==null) {
					Element childEl=element.addElement("mechanism");
					childEl.addAttribute("name", value);
				}
				else target.addAttribute("name", value);
			}
			
			//Do the sStr
			//mytable_0/aaa=bbb, mytable_4/timekey, mytable_4/weakconf, mytable_4/failstop
			strtok2=new StringTokenizer(sStr, ",", false);
			
			//Delete all the parameters inside each mechanism
			Iterator iterator=element.elementIterator();
			while (iterator.hasNext()) {
				Element traverse=(Element) iterator.next();
				if (traverse.getName().equals("mechanism")) {
					//Remove all the children element
					Vector tmpVector=new Vector();
					for (Iterator it2=traverse.elementIterator(); it2.hasNext(); tmpVector.add((Element) it2.next()) );
					for (int i=0; i<tmpVector.size(); i++) {
						Element subChild=(Element)tmpVector.get(i);
						traverse.remove(subChild);
					}
				}
			}
			
			//Adding the paramters
			while (strtok2.hasMoreTokens() ) {
				token=strtok2.nextToken().trim();
				
				StringTokenizer strtok3=new StringTokenizer (token, "/", false);
				String tableStr=strtok3.nextToken();
				String value=strtok3.nextToken();
				
				int rowVal=Integer.parseInt(tableStr.substring(tableStr.lastIndexOf("_")+1));
				
				//traverse to the right node
				Element target=null;
				Iterator it=element.elementIterator();
				
				while (it.hasNext()) {
					Element traverse=(Element) it.next();
					if (traverse.getName().equals("mechanism")) {
						if (rowVal!=0) rowVal--;
						// The right parent node
						else {
							target=traverse;
							break;
						}
					}
				}
				
				String childName=value.substring(0, value.indexOf("="));
				String param=value.substring(value.indexOf("=")+1);
				
				Element newElement=target.addElement("mechParam");
				newElement.addAttribute("name", childName);
				newElement.addAttribute("value", param);
			}
			
		} else if (name.equals("pick")) {
			StringTokenizer strtok2=new StringTokenizer(mStr, ",", false);
			while (strtok2.hasMoreTokens() ) {
				String token=strtok2.nextToken().trim();
				
				String row=token.substring(0, token.indexOf("-") );
				String tableStr=token.substring(token.indexOf("-")+1, token.lastIndexOf("/"));
				String value=token.substring(token.lastIndexOf("/")+1);
				
				int rowVal=Integer.parseInt(row);
				
				if (tableStr.equals("mytable_0")) {
					if (!value.equals("delete")) element.addElement(value.toLowerCase());
					else {
						XPath xpath= DocumentHelper.createXPath("config["+(rowVal+1)+"]");
						Node childNode=xpath.selectSingleNode(element);
						element.remove(childNode);
					}
				}
			}
		}  else if (name.equals("mechanism")) {
			//Just to do setStr
			StringTokenizer strtok2=new StringTokenizer(sStr, ",", false);
			
			//Delete all the parameters inside each mechanism
			Vector tmpVector=new Vector();
			for (Iterator iterator=element.elementIterator(); iterator.hasNext(); tmpVector.add((Element) iterator.next()) );
			for (int i=0; i<tmpVector.size(); i++) {
				Element subChild=(Element)tmpVector.get(i);
				element.remove(subChild);
			}
			
			//Adding the paramters
			while (strtok2.hasMoreTokens() ) {
				String token=strtok2.nextToken().trim();
				
				StringTokenizer strtok3=new StringTokenizer (token, "/", false);				
				String tableStr=strtok3.nextToken();
				String value=strtok3.nextToken();
				
				int rowVal=Integer.parseInt(tableStr.substring(tableStr.lastIndexOf("_")+1));
				String childName=value.substring(0, value.indexOf("="));
				String param=value.substring(value.indexOf("=")+1);
				
				Element newElement=element.addElement("mechParam");
				newElement.addAttribute("name", childName);
				newElement.addAttribute("value", param);
			}
			
		} else if (name.equals("predicate")) {
			Vector childVec=new Vector();

			//Delete the set first
			for (Iterator it=element.elementIterator("param"); it.hasNext(); childVec.add((Element) it.next()) );
			for (int i=0; i<childVec.size(); i++) {
				Element child=(Element)childVec.get(i);
				element.remove(child);
			}
			
			StringTokenizer strtok2=new StringTokenizer(sStr, ",", false);
			while (strtok2.hasMoreTokens() ) {
				String token=strtok2.nextToken().trim();
				
				StringTokenizer strtok3=new StringTokenizer (token, "/", false);				
				String tableStr=strtok3.nextToken();
				String value=strtok3.nextToken();				
				
				if (tableStr.equals("mytable_0")) {
					Element childEl=element.addElement("param");
					childEl.addAttribute("value", value);
				}
			}
		} else {
			throw new AppException("Unexpected node level -- GUI_update_RequestHandler");
		}
		
		//write back the tree to the disk
		writeXmlFile(xmlFile, document);
	}
	
	private void handleAttribute(StringTokenizer strtok, File xmlFile, Map paramMap) {
		//Open and read the XML file.
		Document document=null;
		try {
			SAXReader reader = new SAXReader();
			document = reader.read(xmlFile);
		} catch (Exception e) {
			System.out.println("Cannot read xmlFile.");
		}
		
		Element element=document.getRootElement();
		
		while (strtok.hasMoreTokens() ) {
			//traversing to the right node in the XML file
			String token=strtok.nextToken();
			
			String name=null;
			int loop=0;
			//Extracting the number
			for (int i=token.length()-1; i>=0; i--) {
				if (token.charAt(i)<'0' || token.charAt(i)>'9') {
					loop=Integer.parseInt(token.substring(i+1));
					name=token.substring(0, i+1);
					break;
				}
			}

			Iterator it=null;
			if (name.equals("tag")) it=element.elementIterator("attribute");
			else it=element.elementIterator("set");

			Element target=(Element) it.next();
			for (int i=0;i<loop; i++) target=(Element) it.next();
			element=target;
		}
		
		if (element==document.getRootElement()) {
			String[] modSetStr=(String[]) paramMap.get("modSetStr");
			String mStr=((String[]) paramMap.get("modSetStr"))[0];
			StringTokenizer mStrTok=new StringTokenizer(mStr, ",", false);
			
			while (mStrTok.hasMoreTokens() ) {
				String token=mStrTok.nextToken().trim();
				if (token.charAt(0) == '-') {
					//deleting the node
					XPath xpath= DocumentHelper.createXPath("attribute["+(Integer.parseInt(token.substring(1))+1)+"]");
					Node delNode=xpath.selectSingleNode(element);					
					element.remove(delNode);
				} else {
					//inserting and/or modifying the node name
					String rowStr=token.substring(0, token.indexOf("-"));
					try {
						String newName=token.substring(token.indexOf("-")+1);
						XPath xpath= DocumentHelper.createXPath("attribute["+(Integer.parseInt(rowStr)+1)+"]");
						Node modNode=xpath.selectSingleNode(element);
					
						if (modNode==null) modNode=element.addElement("attribute");
						((Element) modNode).addAttribute("tag", newName);
					} catch (IndexOutOfBoundsException e) {
						//No name for that attribute. Ignore it.
					}
				}
			}
		}
		else {
		//delete all the param value
		Iterator it=element.elementIterator("param");
		
		Vector childVec=new Vector();
		for (; it.hasNext(); ) {
			childVec.add((Element) it.next());
		}
		
		for (int i=0; i<childVec.size(); i++) {
			Element child=(Element)childVec.get(i);
			element.remove(child);
		}
		
		//add the user param to here
		it=paramMap.keySet().iterator();
		for (;it.hasNext();) {
			String paramName=(String) it.next();
			if (IsIntStr(paramName)) {
				//create a new element
				Element child=element.addElement("param");
				String[] valArray=(String[])paramMap.get(paramName);
				child.addAttribute("value", valArray[0]);
			}
		}
/*		
		try {
			(new XMLWriter(System.out)).write(element);
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
*/		
		//Modifying the appropriate sets here
		String[] modSetStr=(String[]) paramMap.get("modSetStr");
		String mStr=modSetStr[0];
		StringTokenizer mStrToken=new StringTokenizer(mStr, ",", false);

		while (mStrToken.hasMoreTokens()) {
			String token=mStrToken.nextToken().trim();
			if (token.charAt(0)!='-') element.addElement("set");				
			else {
				XPath xpath= DocumentHelper.createXPath("set["+(Integer.parseInt(token.substring(1))+1)+"]");
				Node delNode=xpath.selectSingleNode(element);
				element.remove(delNode);
			}			
		}
		
		}
		//write back the tree to the disk
		writeXmlFile(xmlFile, document);
	}
	
	private void writeXmlFile(File xmlFile, Document document) {
		//writing the XML file back to disk
        // lets write to a file
		try {
			XMLWriter writer = new XMLWriter(new FileWriter(xmlFile), OutputFormat.createPrettyPrint());
			writer.write( document );
			writer.close();
		} catch (Exception e) {}
	}
	
	private boolean IsIntStr(String str) {
		try {
			Integer.parseInt(str);
		} catch (Exception e) {
			return false;
		}
		return true;
	}
}