package AntigoneUI;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;

//Own application classes
import AntigoneUI.DB.*;
import AntigoneUI.GUI.*;

public class RequestController extends HttpServlet
{
	public void doPost (HttpServletRequest request, HttpServletResponse response) 
		throws IOException
	{
		doGet(request, response);
	}
	
	public void doGet (HttpServletRequest request, HttpServletResponse response) 
		throws IOException
	{
		HttpSession session=request.getSession();
		ServletContext context=session.getServletContext();
		String nextPage="";
		try {
			String action=request.getParameter("action");
			if (action==null || action.equals("null") ) throw new AppException("User no action found!");

			if (action.startsWith("DB")) {
				RequestManager manager=(RequestManager) session.getAttribute("DBRequestManager");
				if (manager==null) {
					manager=new DBRequestManager(getInitParameter("driver"), getInitParameter("url") );
					session.setAttribute( "DBRequestManager" ,manager);
				}
				//fetching the next page
				nextPage=manager.dispatchRequest(request);
			}

			else if (action.startsWith("GUI")) {
				RequestManager manager=(RequestManager) session.getAttribute("GUIRequestManager");
				if (manager==null) {
					manager=new GUIRequestManager();
					session.setAttribute( "GUIRequestManager" ,manager);
				}
				nextPage=manager.dispatchRequest(request);
			}
			else nextPage=action;			
		} catch (AppException e) {
			session.setAttribute("errMsg", e.getMessage() );
			nextPage="/error.jsp";
		} finally {
			System.out.println("Forwarding to: "+nextPage);
			RequestDispatcher dispatcher=context.getRequestDispatcher(nextPage);
			try {
				dispatcher.forward(request, response);
			} catch (Exception e) {}
		}
	}
}