package AntigoneUI.Servlets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
import java.io.*;

//Own application class
import AntigoneUI.*;
import AntigoneUI.DB.*;
import Converter.*;

public class Download1Servlet extends HttpServlet 
{
	//The second time it is forward to the servlet
	public void doGet(HttpServletRequest request, HttpServletResponse response) 
		throws IOException
	{
		//Check user has login
		HttpSession session=request.getSession();
		String id=(String) session.getAttribute("id");
		String user=(String) session.getAttribute("user");
		String format=request.getParameter("format");
		String nextPage="/request?action=DB_userfile_RequestHandler";
		
		try {
			if (id==null) throw new AppException ("User is not authenticated to download files!");
			
			//Form the file path
			String sep=File.separator;
			String fileName=((String) session.getAttribute("downloadFile"));
			String path=session.getServletContext().getRealPath("/users"+sep+user+sep+fileName);
			
			System.out.println(path);
			
			if (format.equals("XML")) {
				//Opening the servlet stream
				response.setContentType("text/xml");
				//response.addHeader("content-disposition","attachment; filename="+fileName+".xml");
				ServletOutputStream out = response.getOutputStream();
				
				// print the file
				path+=".xml";
				InputStream in = new BufferedInputStream(new FileInputStream(path), 1);
				try {
					int ch;
					while ((ch = in.read()) !=-1) 
						out.print((char)ch);
				} catch (Exception e) {}
				finally {
					in.close();
					out.close();
				}
			} else if (format.equals("Ismene")) {
				response.setContentType("text/plain");
				//response.addHeader("content-disposition","attachment; filename="+fileName);
				ServletOutputStream out = response.getOutputStream();
				
				//Converting the XML to policy file.
				String [] convertstrings=new String[2];
				convertstrings[0]=path+".xml";
				convertstrings[1]=path;
				toIsmene conversion=new toIsmene(convertstrings);
				
				// print the file
				InputStream in = new BufferedInputStream(new FileInputStream(path), 1);
				try {
					int ch;
					while ((ch = in.read()) !=-1) 
						out.print((char)ch);
				} catch (Exception e) {}
				finally {
					in.close();
					out.close();
				}
			} else throw new AppException ("Invalid file download format requested!");
		}
		catch (AppException e) {
			session.setAttribute("errMsg", e.getMessage());
			nextPage="/error.jsp";
		} finally {
			//forwarding user to next page			
			RequestDispatcher rd=session.getServletContext().getRequestDispatcher(nextPage);
			try {
				System.out.println("forwarding back...");
				rd.forward(request, response);
			} catch (Exception e) {}
		}
	}
	
	//The first time it is forward to the servlet
	public void doPost(HttpServletRequest request, HttpServletResponse response) 
		throws IOException
	{
		//Check user has login
		HttpSession session=request.getSession();
		String id=(String) session.getAttribute("id");
		String user=(String) session.getAttribute("user");
		String nextPage="/JspSupport/downloadFile.jsp";
		
		try {
			if (id==null) throw new AppException ("User is not authenticated to download files!");
			String fileName=request.getParameter("radiobutton");
			
			//System.out.println(fileName);
			
			if (fileName!=null) {
				session.setAttribute("downloadFile", fileName);
			} else throw new AppException ("User hasn't chosen a file.");			
		} catch (AppException e) {
			session.setAttribute("errMsg", e.getMessage());
			nextPage="/error.jsp";
		} finally {
			//forwarding user to next page
			RequestDispatcher rd=session.getServletContext().getRequestDispatcher(nextPage);
			try {
				rd.forward(request, response);
			} catch (Exception e) {}
		}
	}
}