package AntigoneUI.Servlets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;
import java.io.*;

//Own application class
import AntigoneUI.*;
import AntigoneUI.DB.*;
import Converter.*;

//Third party class
import com.oreilly.servlet.multipart.*;

public class UploadServlet extends HttpServlet
{
	private static final String queryStr1="DELETE FROM USER_FILES WHERE id=? AND IsmeneFile=?";
	private static final String queryStr2="INSERT INTO USER_FILES VALUES(?, ?, ?)";
	private static final int FILESIZE=1*1024*1024; //1MB
	
	public void doPost(HttpServletRequest request, HttpServletResponse response) 
		throws IOException
	{
		//Check user has login
		HttpSession session=request.getSession();
		String id=(String) session.getAttribute("id");
		String user=(String) session.getAttribute("user");
		String nextPage="/request?action=DB_userfile_RequestHandler";

		try {
			if (id==null) throw new AppException ("User is not authenticated to access database!");
		
			System.out.println("Uploading file...");
			String path="";
			String fileName="";

			try {
				MultipartParser mp = new MultipartParser(request, FILESIZE); // 1MB
				Part part;
				while ((part = mp.readNextPart()) != null) {
					if (part.isFile() ) {
						FilePart filePart = (FilePart) part;
						fileName = filePart.getFileName();
						if (fileName != null) {
						
							//Form the file path
							String sep=File.separator;
							path=session.getServletContext().getRealPath("/users"+sep+user+sep+fileName);

							//Writing out the file
							File outFile= (new File(path)).getCanonicalFile();
							path=outFile.getPath();
							long size = filePart.writeTo(outFile);
						}
					}
				}
			} catch (Exception e) {
				throw new AppException ("Cannot create user file.");
			}
		
			//Converting the policy file to XML
			String [] convertstrings=new String[2];
			convertstrings[0]=path;
			convertstrings[1]=path+".xml";
			Conversion conversion=new Conversion(convertstrings);
		
			//Update the DataBase
			DBRequestManager man=(DBRequestManager)session.getAttribute("DBRequestManager");
			Connection connection=man.getConnection();
	
			//First delete the duplicate one and then insert it back
			try {
				PreparedStatement preparedStatement1 = connection.prepareStatement(queryStr1);
				preparedStatement1.setShort(1, Short.parseShort(id) );
				preparedStatement1.setString(2, fileName);
				
				PreparedStatement preparedStatement2 = connection.prepareStatement(queryStr2);
				preparedStatement2.setShort(1, Short.parseShort(id) );
				preparedStatement2.setString(2, fileName);
				preparedStatement2.setString(3, fileName+".xml");
				
				//Executing the SQL statements.
				preparedStatement1.executeUpdate();
				preparedStatement2.executeUpdate();
				} catch (Exception e) {
				throw new AppException ("Update DB failed.");
			}
		} catch (AppException e) {
			session.setAttribute("errMsg", e.getMessage());
			nextPage="/error.jsp";
		} finally {
			//forwarding user to next page
			RequestDispatcher rd=session.getServletContext().getRequestDispatcher(nextPage);
			try {
				rd.forward(request, response);
			} catch (Exception e) {}
		}
	}
}